﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3

// release 1.0b0 on 19-08-06 by jjw

#pragma version = 1.00
#pragma IgorVersion = 8

// uncomment to debug
//#define DEBUG

// ***
// VARIABLES

// package definitions
Static StrConstant k_packageFolder = "root:Packages:imgT"
Static StrConstant k_graphName = "imgT_display"
Static StrConstant k_panelName = "imgT_panel"
Static StrConstant k_histfolder = "imgT_hist"

// panel dimensions
Static Constant pleft = 500
Static Constant ptop = 50
Static Constant pwidth = 415
Static Constant pheight = 550
Static Constant gwidth = 600

// menu placement
Menu "Packages"
	SubMenu "Panels"
		"Image Tools", /Q, StartImageTools()
	end
end

// ***
// STRUCTURES

// structure to collect load instructions
Structure LoadSettings
	variable source
	variable gray
	variable red
	variable green
	variable blue
	variable howmany
	variable startimage
	variable stepimage
	variable endimage
	variable startindex
	variable stepindex
EndStructure

// populate the structure
Function GetLoadSettings(ls)
	STRUCT LoadSettings &ls
	
	ControlInfo/W=$k_panelName checkgsource_tab0
	ls.source = v_value
	ControlInfo/W=$k_panelName checkgred_tab0
	ls.red = v_value
	ControlInfo/W=$k_panelName checkggreen_tab0
	ls.green = v_value
	ControlInfo/W=$k_panelName checkgblue_tab0
	ls.blue = v_value
	ControlInfo/W=$k_panelName checkggray_tab0
	ls.gray = v_value
	
	ls.howmany = ls.source + ls.gray + ls.red + ls.green + ls.blue

	ControlInfo/W=$k_panelName startimg_tab0
	ls.startimage = v_value
	ControlInfo/W=$k_panelName stepimg_tab0
	ls.stepimage = v_value
	ControlInfo/W=$k_panelName endimg_tab0
	ls.endimage = v_value
	ControlInfo/W=$k_panelName startind_tab0
	ls.startindex = v_value
	ControlInfo/W=$k_panelName stepind_tab0
	ls.stepindex = v_value
	
	return 0
end

// structure to collect folder + file values
Structure iDisplay
	string folder
	string file
EndStructure

// fill the folder + file structure from panel
Function GetImageDir(iD)
	STRUCT iDisplay &iD
	
	ControlInfo/W=$k_panelName popupfolder_tab0
	id.folder = "imgT_" + s_value
	ControlInfo/W=$k_panelName popupfile_tab0
	id.file = "img_" + s_value
	
	return 0
end

// fill the folder + file structure manually
// pass paramters with prefixes!!!
Function SetImagetoShow(sfolder, sfile)
	string sfolder, sfile
	
	// globals for package	
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string flist
	variable itn
	
	// set the folder
	cwdfolder = sfolder	
	flist = LoimgT()
	itn = WhichListItem(sfolder[5,inf],flist) + 1	
	Popupmenu popupfolder_tab0, win=$k_panelName, mode=itn
	
	// set the file
	cwfile = sfile
	flist = LoimgF()
	itn = WhichListItem(sfile[5,inf],flist) + 1
	Popupmenu popupfile_tab0, win=$k_panelName, mode=itn
	
	return 0
end

// structure to collect marquee or hRoI coordinates
Structure MarqueeCoordinates
	variable hasmarquee
	variable hasdrawing
	variable paleft
	variable paright
	variable patop
	variable pabottom
	variable pgleft
	variable pgright
	variable pgtop
	variable pgbottom
EndStructure

// fill the structure
Function GetMCCoordinates(mc)
	Struct MarqueeCoordinates &mc
	
	GetMarquee/W=$k_graphName/Z
	mc.hasmarquee = v_flag
	DrawAction/W=$k_graphName/L=ProgFront getgroup=hRoI, extractOutline
	mc.hasdrawing = v_flag
	
	variable pntsh, pxlsh, pntsppxl

	// hRoI drawing overrides marquee
	if (mc.hasdrawing == 1)
		wave w_polyx, w_polyy
		mc.pgleft=w_polyx[0]
		mc.pgright=w_polyx[1]
		mc.pgtop=w_polyy[1]
		mc.pgbottom=w_polyy[2]
		getwindow $k_graphName, psizeDC
		pxlsh = V_right-V_left
		getwindow $k_graphName, psize
		pntsh = V_right-V_left  
		pntsppxl = pntsh / pxlsh
		mc.paleft = PixelFromAxisVal(k_graphName,"left",mc.pgleft)*pntsppxl
		mc.patop = PixelFromAxisVal(k_graphName,"top",mc.pgtop)*pntsppxl
		mc.paright = PixelFromAxisVal(k_graphName,"left",mc.pgright)*pntsppxl
		mc.pabottom = PixelFromAxisVal(k_graphName,"top",mc.pgbottom)*pntsppxl
		killwaves/Z w_polyx, w_polyy
		return 0
	endif	
	
	// no hRoI drawing or marquee
	if (mc.hasmarquee == 0)
		mc.paleft = NaN; mc.patop = NaN; mc.paright = NaN; mc.pabottom = NaN
		mc.pgleft = NaN; mc.pgtop = NaN; mc.pgright = NaN; mc.pgbottom = NaN
		return 0
	endif
	
	// marquee
	mc.paleft = v_left
	mc.paright = v_right
	mc.patop = v_top
	mc.pabottom = v_bottom	
	GetMarquee/W=$k_graphName/Z left,top
	mc.pgleft = v_left
	mc.pgright = v_right
	mc.pgtop = v_top
	mc.pgbottom = v_bottom	
	return 0
end

// ***
// HOOK FUNCTIONS

// window hook function
Function imgTGraphHook(igH)		// WindowHookFunction
	STRUCT WMWinHookStruct &igH
	
	variable hookResult = 0, cx, cy
	
	switch(igH.eventCode)
		case 7:		// cursor moved
			if (WinType(k_panelName)==0)
				hookresult = 1
				break
			endif
			if (strlen(CsrInfo(A,k_graphName))!=0)
				ValDisplay valdispcx_tab0, win=$k_panelName, value=_NUM:xcsr(A,k_graphName)
				ValDisplay valdispcy_tab0, win=$k_panelName, value=_NUM:vcsr(A,k_graphName)
			else
				ValDisplay valdispcx_tab0, win=$k_panelName, value=_NUM:NaN
				ValDisplay valdispcy_tab0, win=$k_panelName, value=_NUM:NaN
			endif
			hookresult = 1
			break
	endswitch
	
	return hookResult	
end

// panel hook function
Function imgTPanelHook(ipH)		// WindowHookFunction
	STRUCT WMWinHookStruct &ipH
	
	variable hookResult = 0, il, ctab
	
	switch(ipH.eventCode)
		case 0:
			ControlInfo/W=$k_panelName main
			ctab = v_value
#ifdef DEBUG
			print "active at tab", ctab
#endif
			// on tab 0, reset images loaded and reset other tabs active/inactive
			if (ctab == 0)
				ValDisplay valdispNimgs_tab0, win=$k_panelName, value=NImagesLoaded()
			endif
			hookResult = 1
			break
	endswitch
	
	return hookResult	
end

// ***
// STARTUP

// starting point from menu call
Function StartImageTools()

	// initialize?	
	if (!DataFolderExists(":Packages:imgT"))
		InitializePackage()
	endif
	
	// bring window forward or create?
	DoWindow/F $k_graphName
	if (v_flag == 0)
			// create new panel
			CreateImageWindow()
			AppendHistograms(0)
			AppendImageToolsPanel()
			// initialize the tabs
			if (NImagesLoaded() == 0)
				InitializeTabMenus(-1)
			else
				InitializeTabMenus(100)
				ResetImageFileonPanel()
				UpdateContactPrint()
			endif
	endif
		
	return 0
end

// initialize the package folder
Function InitializePackage()

	// create package folder
	SetDataFolder root:	
	NewDataFolder/O/S Packages	
	NewDataFolder/S imgT
	
	// create globals
	// working directory
	string/G cwdfolder = "Packages:imgT", cwfile = "imgT_default"
	make/N=(600,400)/B/U imgT_default
	imgT_default = 200*sin(x)*cos(y)+200
	NewDataFolder/O contactprint
	
	SetDataFolder root:

	return 0
end

// create image window
Function CreateImageWindow()

	// globals for package	
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string stitle, fstr, tstr
	
	// set the folder and image
	fstr = "root:" + cwdfolder
	DFREF imgF = $fstr	
	wave/SDFR=imgF itd = $cwfile

	NewImage/N=$k_graphName itd
	MoveWindow/W=$k_graphName 10,10,-1,-1
	ModifyGraph/W=$k_graphName height={Plan,1,left,top}, axisEnab(left)={0.3,1}, width=gwidth
	SetWindow $k_graphName hook(imgTgraph)=imgTGraphHook
	
	return 0
end

// show histograms
// how = 0 new
// how = 1 replace traces
Function AppendHistograms(how)
	variable how

	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string workf = "root:" + cwdfolder
	DFREF wf = $workf

	variable dhmin, dhmax, xmid
	string imgroot, iHwave, iCHwave, iDHwave, dhistlimits
	string alltraces, htracen, htracel, ctrace, dtrace

	// regenerate the histogram each time
	GenerateHistograms(-1)
	
	workf += ":" + k_histFolder
	DFREF hf = $workf
	
	imgroot = StringFromList(1,cwfile,"_")
	iHwave = "hist_" + imgroot
	iCHwave = "chist_" + imgroot
	iDHwave = "dhist_" + imgroot
	
	wave/SDFR=hf theH = $iHwave
	wave/SDFR=hf theCH = $iCHwave
	wave/SDFR=hf theDH = $iDHwave
	
	WaveStats/Q theDH
	dhmax = v_max
	dhmin = v_min
	sprintf dhistlimits, "%d,%d",dhmin,dhmax
	SetWindow $k_graphName userdata(dhistogram)=dhistlimits
	
	// how = 0 is new; how = 1 is replace
	switch(how)
		case 0:		// new
			AppendtoGraph/R=lhist theH
			htracel = StringFromList(0,TraceNameList("",";",1))
			AppendtoGraph/L=nhist theH
			htracen = StringFromList(1,TraceNameList("",";",1))
			AppendToGraph/L=chist theCH
			ctrace = StringFromList(2,TraceNameList("",";",1))
			AppendtoGraph/R=dhist theDH
			dtrace = StringFromList(3,TraceNameList("",";",1))
			xmid = round(numpnts(theDH)/2)
			
			ModifyGraph rgb=(52428,1,1)
			ModifyGraph lsize=2,standoff=0
			ModifyGraph rgb($htracen)=(1,4,52428), rgb($ctrace)=(1,4,52428)
			ModifyGraph log(lhist)=1,freePos(chist)={0,bottom},freePos(dhist)={inf,bottom}
			ModifyGraph noLabel(lhist)=2,noLabel(lhist)=2,nticks(nhist)=0,nticks(nhist)=0,tick(lhist)=3
			ModifyGraph noLabel(chist)=2,noLabel(dhist)=2,nticks(chist)=0,nticks(dhist)=0,zero(dhist)=2
			ModifyGraph mode($htracen)=1,mode($htracel)=1,lsize($htracen)=1,lsize($htracel)=1
			ModifyGraph freePos(lhist)={inf,bottom},freePos(nhist)={0,bottom}
			ModifyGraph axisEnab(nhist)={0,0.14},axisEnab(lhist)={0,0.14},noLabel(nhist)=2
			ModifyGraph axisEnab(chist)={0.15,0.29},axisEnab(dhist)={0.15,0.29}
			ModifyGraph tick(bottom)=1,noLabel(bottom)=2
			Cursor A $dtrace, xmid
			break
			
		case 1:		// just replace waves
			alltraces = TraceNameList(k_graphName,";",1)
			htracel = StringFromList(0,alltraces)
			ReplaceWave/W=$k_graphName trace=$htracel, theH
			htracen = StringFromList(1,TraceNameList("",";",1))
			ReplaceWave/W=$k_graphName trace=$htracen, theH
			ctrace = StringFromList(2,TraceNameList("",";",1))
			ReplaceWave/W=$k_graphName trace=$ctrace, theCH
			dtrace = StringFromList(3,TraceNameList("",";",1))
			ReplaceWave/W=$k_graphName trace=$dtrace, theDH
			DoUpdate
			if (strlen(CsrInfo(A,k_graphName))==0)
				ValDisplay valdispcx_tab0, win=$k_panelName, value=_NUM:NaN
				ValDisplay valdispcy_tab0, win=$k_panelName, value=_NUM:NaN
			else
				ValDisplay valdispcx_tab0, win=$k_panelName, value=_NUM:xcsr(A,k_graphName)
				ValDisplay valdispcy_tab0, win=$k_panelName, value=_NUM:vcsr(A,k_graphName)
			endif
			break
	endswitch
	
	// scale the histogram according to slider
	ControlInfo/W=$k_panelName slidermagdhist_tab0
	ScaleDHistogram(v_value)

	return 0
end

// show/hide histogram tab
// how = 0 show
// how = 1 hide
Function ShowHideHistograms(how)
	variable how
	
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	variable rRoI, lRoI
	string ftn, hstr="hist_", hstr1, chstr="chist_", dhstr="dhist_"
	
	// get current disable states
	rRoI = str2num(GetUserData(k_panelname,"checksethRoI_tab0","state"))
	lRoI = str2num(GetUserData(k_panelname,"checklockhRoI_tab0","state"))
	if (numtype(rRoI)!=0)
		rRoI = 1
		lRoI = 1
	endif
	
	ftn = StringFromList(0,(TraceNameList(k_graphName,";",1)))
	
	if (strsearch(ftn,"default",0) > 0)
		ftn = "default"
	else
		ftn = StringFromList(1,cwfile,"_")		
	endif
	
	hstr += ftn ; hstr1 = hstr+"#1"; chstr += ftn; dhstr += ftn

	switch(how)
		case 0:
			ModifyGraph/W=$k_graphName hideTrace($hstr1)=0, hideTrace($hstr)=0, hideTrace($chstr)=0, hideTrace($dhstr)=0
			ModifyGraph/W=$k_graphName zero(dhist)=3, axisEnab(left)={0.3,1}, tick(bottom)=1
			Cursor A $dhstr, 128
			Button buttonRedoH_tab0, win=$k_panelName, disable = 0
			Slider slidermagdhist_tab0, win=$k_panelName, disable = 0
			CheckBox checksethRoI_tab0, win=$k_panelName, disable = rRoI
			CheckBox checklockhRoI_tab0, win=$k_panelName, disable = lRoI
			break
		case 1:
			Cursor/K A
			ModifyGraph/W=$k_graphName hideTrace($hstr1)=2, hideTrace($hstr)=2, hideTrace($chstr)=2, hideTrace($dhstr)=2
			ModifyGraph/W=$k_graphName zero=0, axisEnab(left)={0,1}, tick(bottom)=3
			Button buttonRedoH_tab0, win=$k_panelName, disable = 2
			Slider slidermagdhist_tab0, win=$k_panelName, disable = 2
			ControlInfo/W=$k_panelName checksethRoI_tab0
			CheckBox checksethRoI_tab0, win=$k_panelName, userdata(state)=num2str(v_disable)
			ControlInfo/W=$k_panelName checklockhRoI_tab0
			CheckBox checklockhRoI_tab0, win=$k_panelName, userdata(state)=num2str(v_disable)
			CheckBox checklockhRoI_tab0, win=$k_panelName, disable = 2
			CheckBox checksethRoI_tab0, win=$k_panelName, disable = 2
			CheckBox checklockhRoI_tab0, win=$k_panelName, disable = 2
			break
	endswitch
	
	return 0	

end

// append the panel
Function AppendImageToolsPanel()

	variable tvoffset = 0
	
	// panel frame
	NewPanel/EXT=0/HOST=$k_graphName/W=(0,0,pwidth,pheight)/N=$k_panelName/K=1 as "Image Tools Panel"
#ifndef DEBUG
	ModifyPanel fixedSize=1, noEdit=1
#endif
	SetWindow $k_panelName hook(imgTact)=imgTPanelHook
	
	// tab controls
	
	TabControl main,pos={0,4},size={pwidth,25},proc=TabProc
	TabControl main,fSize=16,tabLabel(0)="Main", value=0
	TabControl main,help={"Load TIFF images or choose which image to display."}
	
	// tab 0 - load/display

	tvoffset = 28
	
	TitleBox load_tab0,pos={12,tvoffset},size={84,22},title="Load TIFF(s)"
	TitleBox load_tab0,fSize=18,frame=0,fStyle=1,disable=0

	tvoffset = 60
	
	PopupMenu popupload_tab0,pos={22,tvoffset},size={113,23},title="What"
	PopupMenu popupload_tab0,mode=1,popvalue="One File",value= #"\"One File;Many Files;Entire Folder;Image Stack;\""
	PopupMenu popupload_tab0,fSize=14,disable=0,proc=popmenuproc
	
	ValDisplay valdispNimgs_tab0 title="Image Sets Loaded",pos={220,tvoffset},size={180,20}, fSize=14
	ValDisplay valdispNimgs_tab0 value=NImagesLoaded()

	tvoffset += 25
	
	SetVariable startimg_tab0, pos={25,tvoffset},size={120,16},title="Start At"
	SetVariable startimg_tab0, fSize=12,value=_NUM:1, limits={1,inf,1}, disable=2
	SetVariable endimg_tab0, pos={25+130,tvoffset},size={120,16},title="Load Only"
	SetVariable endimg_tab0, fSize=12,value=_NUM:inf, limits={1,inf,1}, disable=2
	SetVariable stepimg_tab0, pos={25+260,tvoffset},size={120,16},title="Step By"
	SetVariable stepimg_tab0, fSize=12,value=_NUM:1, limits={1,inf,1}, disable=2
	
	tvoffset += 25
	
	SetVariable startind_tab0, pos={25,tvoffset},size={120,16},title="Start Label"
	SetVariable startind_tab0, fSize=12,value=_NUM:0, limits={0,inf,1}, disable=2
	SetVariable stepind_tab0, pos={25+130,tvoffset},size={120,16},title="Step Label"
	SetVariable stepind_tab0, fSize=12,value=_NUM:1, limits={1,inf,1}, disable=2
	
	tvoffset +=30
	
	CheckBox checkgsource_tab0,pos={35,tvoffset},size={76,16},title="keep source"
	CheckBox checkgsource_tab0,fSize=10,value=1
	CheckBox checkgred_tab0,pos={35,tvoffset+24},size={102,16},title="extract red image"
	CheckBox checkgred_tab0,fSize=10,value=0
	CheckBox checkggreen_tab0,pos={35,tvoffset+24+18},size={114,16},title="extract green image"
	CheckBox checkggreen_tab0,fSize=10,value=0
	CheckBox checkgblue_tab0,pos={35,tvoffset+24+36},size={107,16},title="extract blue image"
	CheckBox checkgblue_tab0,fSize=10,value=0
	CheckBox checkgGray_tab0,pos={35,tvoffset+24+54},size={109,16},title="generate grayscale"
	CheckBox checkgGray_tab0,fSize=10,value=0
	
	tvoffset += 24 + 54 + 20
	
	Button buttonLoad_tab0,pos={300,tvoffset},size={80,25},proc=ButtonProc,title="Load"
	Button buttonLoad_tab0,fSize=18,disable=0
	
	// Display Image Section
	
	tvoffset += 60
	
	TitleBox display_tab0,pos={15,tvoffset},size={122,22},title="Display/Print"
	TitleBox display_tab0,fSize=18,frame=0,fStyle=1,disable=0

	tvoffset += 25
	
	Button buttonleft_tab0 title="<",pos={20,tvoffset},size={20,20},proc=ButtonProc,fSize=14,disable=0
	Button buttonright_tab0 title=">",pos={45,tvoffset},size={20,20},proc=ButtonProc,fSize=14,disable=0
	
	PopupMenu popupfolder_tab0,pos={65,tvoffset},size={175,23},proc=PopMenuProc,title=""
	PopupMenu popupfolder_tab0,fSize=14,mode=1,value= #"LoimgT()",disable=0
	
	tvoffset += 30
	
	PopupMenu popupfile_tab0,pos={20,tvoffset},size={106,23},proc=PopMenuProc,title=""
	PopupMenu popupfile_tab0,fSize=14,mode=1,value= #"LoimgF()",disable=0
	
	CheckBox checkCP_tab0,pos={140,tvoffset},size={20,20},title="use for contact print"
	CheckBox checkCP_tab0,fSize=10,value=0,proc=CheckProc,disable=0
	
	ValDisplay valdispccp_tab0, pos={280,tvoffset+1}, title="contact prints"
	ValDisplay valdispccp_tab0 size={100,20},value=_NUM:0,fSize=10
	
	tvoffset += 25
	
	Button buttonClearAll_tab0, pos={140,tvoffset-1},size={120,22},title="Clear Contact Images"
	Button buttonClearAll_tab0,fSize=10,proc=ButtonProc,disable=0
	
	Button buttonDoCPrint_tab0, pos={280,tvoffset-1},size={120,22},title="Make Contact Layout"
	Button buttonDoCPrint_tab0,fSize=10,proc=ButtonProc,disable=0
	
	// Histogram Control Section
	
	tvoffset += 35
	
	TitleBox historslice_tab0,pos={15,tvoffset},size={122,22},title="Histograms"
	TitleBox historslice_tab0,fSize=16,frame=0,fStyle=1,disable=0

	CheckBox checkshowHist_tab0,pos={120,tvoffset+2},size={20,20},title="hide histograms"
	CheckBox checkshowHist_tab0,fSize=10,value=0,proc=CheckProc,disable=0
	
	tvoffset += 25
	
	Button buttonRedoH_tab0,pos={20,tvoffset},size={40,25},proc=ButtonProc,title="Redo"
	Button buttonRedoH_tab0,fSize=12,disable=0

	CheckBox checksethRoI_tab0,pos={75,tvoffset},size={20,20},title="restrict\rto RoI"
	CheckBox checksethRoI_tab0,fSize=10,value=0,proc=CheckProc,disable=0,userdata(state)="0"

	CheckBox checklockhRoI_tab0,pos={135,tvoffset},size={20,20},title="lock\rRoI"
	CheckBox checklockhRoI_tab0,fSize=10,value=0,proc=CheckProc,disable=0,userdata(state)="0"

	tvoffset += 30
	
	Slider slidermagdhist_tab0 pos={20,tvoffset},value=0,limits={0,3,0.2}
	Slider slidermagdhist_tab0 proc=SliderProc,size={60,60},ticks=0,disable=0
	
	TitleBox histscale_tab0,pos={40,tvoffset+10},size={122,22},title="scale\rderivative"
	TitleBox histscale_tab0,fSize=10,frame=0,disable=0
	
	ValDisplay valdispcx_tab0 pos={100,tvoffset+10}, title="x",size={60,20},value=_NUM:xcsr(A,k_graphName),fSize=10
	ValDisplay valdispcy_tab0 pos={100,tvoffset+30}, title="y",size={80,20},value=_NUM:vcsr(A,k_graphName),fSize=10
	
	return 0
end

// ***
// SUPPORT FUNCTIONS

// initialize menu options for a given tab
Function InitializeTabMenus(tab)
	variable tab
	
	DFREF pf=$k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
#ifdef DEBUG
	print "initializing tab ", tab
#endif

	switch(tab)
		case -1:		// initialize package
			CheckBox/Z checkCP_tab0, win=$k_panelName, value=0, disable=2
			CheckBox/Z checksethRoI_tab0, win=$k_panelName, value=0, disable=2,userdata(state)="2"
			CheckBox/Z checklockhRoI_tab0, win=$k_panelName, value=0, disable=2,userdata(state)="2"
			ValDisplay valdispccp_tab0 win=$k_panelName, value=_NUM:CountofContactPrints(), disable = 2
			PopupMenu/Z popupfolder_tab0 win=$k_panelName, disable = 2
			PopupMenu/Z popupfile_tab0 win=$k_panelName, disable = 2
			Button/Z buttonleft_tab0 win=$k_panelName, disable = 2
			Button/Z buttonright_tab0 win=$k_panelName, disable = 2
			Button/Z buttonClearAll_tab0 win=$k_panelName, disable = 2
			Button/Z buttonDoCPrint_tab0 win=$k_panelName, disable = 2
			break
		case 100:		// load first image
			CheckBox/Z checkCP_tab0, win=$k_panelName, value=0, disable=0
			CheckBox/Z checksethRoI_tab0, win=$k_panelName, value=0, disable=0
			ValDisplay valdispccp_tab0 win=$k_panelName, value=_NUM:CountofContactPrints(), disable = 0
			PopupMenu/Z popupfolder_tab0 win=$k_panelName, disable = 0
			PopupMenu/Z popupfile_tab0 win=$k_panelName, disable = 0
			Button/Z buttonClearAll_tab0 win=$k_panelName, disable = 0
			Button/Z buttonDoCPrint_tab0 win=$k_panelName, disable = 0
			SetImagetoShow(cwdfolder, cwfile)
			ResetImageFileonPanel()
			break		
		default:
			CheckBox/Z checklockhRoI_tab0, win=$k_panelName, value=0, disable=2
			ValDisplay valdispccp_tab0 win=$k_panelName, value=_NUM:CountofContactPrints()
			// no folder or image set for tab 1 menus
			if (strlen(cwdfolder)==0)
				// set to first folder and first file
				cwdfolder = "imgT_" + StringFromList(0,LoimgT())
				cwfile = StringFromList(0,LoimgF(sfolder=cwdfolder))
			endif
			SetImagetoShow(cwdfolder,cwfile)
			ResetImageFileonPanel()
			break
	endswitch
	
	return 0
end

// lock the histogram to a RoI
Function LockHistogramRoI(yn)
	variable yn

	variable ppx0, ppx1, ppy0, ppy1
	STRUCT MarqueeCoordinates mc
	GetMCCoordinates(mc)

	switch(yn)
		case 0:		// unlock
			SetDrawLayer/W=$k_graphName ProgFront
			DrawAction/W=$k_graphName getgroup=hRoI, delete
			SetDrawLayer/W=$k_graphName UserFront
			SetMarquee/W=$k_graphName, mc.paleft,mc.patop,mc.paright,mc.pabottom
			CheckBox/Z checksethRoI_tab0, win=$k_panelName, disable=0
			break
		case 1:		// lock
			// get marquee from image graph	
			if (!mc.hasmarquee && !mc.hasdrawing)
				//if (!quiet)
				//	DoAlert/T="Restrict Histogram" 0, "No marquee region or locked histogram drawing is present. Set one a marquee try again."
				//endif
				Checkbox checklockhRoI_tab0, win=$k_panelName, value=0
				return 0
			endif
			
			// put trunated pixel coordinates in local variables
			ppx0 = trunc(mc.pgleft)
			ppy0 = trunc(mc.pgtop)
			ppx1 = trunc(mc.pgright)
			ppy1 = trunc(mc.pgbottom)
			SetDrawLayer/W=$k_graphName ProgFront
			SetDrawEnv/W=$k_graphName gstart,gname=hRoI
			SetDrawEnv/W=$k_graphName linefgc=(65535,0,0),linethick=2,fillpat=0, xcoord=top,ycoord=left, save
			DrawRect/W=$k_graphName ppx0,ppy0,ppx1,ppy1
			SetDrawEnv/W=$k_graphName gstop
			SetDrawLayer/W=$k_graphName UserFront
			CheckBox/Z checksethRoI_tab0, win=$k_panelName, disable=2
			break
	endswitch
	
	return 0
end

// clean up tab menu options for a given tab
Function CleanupTabControls(tab)
	variable tab
	
	DFREF pf=$k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
#ifdef DEBUG
	print "cleaning up tab ", tab
#endif

	variable istack
	switch(tab)
		case 0:
			// remove/show setvariables
			ControlInfo/W=$k_panelName popupload_tab0
			istack = v_value == 4 ? 0 : 2
			SetVariable/Z startimg_tab0, win=$k_panelName, disable=istack
			SetVariable/Z stepimg_tab0, win=$k_panelName, disable=istack
			SetVariable/Z endimg_tab0, win=$k_panelName, disable=istack
			SetVariable/Z startind_tab0, win=$k_panelName, disable=istack
			SetVariable/Z stepind_tab0, win=$k_panelName, disable=istack

			CheckBox/Z checklockhRoI_tab0, win=$k_panelName, value=0, disable=2
			break
		default:
			// disable/enable scroll buttons
			if ((strlen(LoimgT())==0) || (ItemsInList(LoimgT())==1))
				Button/Z buttonleft_tab0, win=$k_panelName, disable=2
				Button/Z buttonright_tab0,win=$k_panelName, disable=2
			else
				Button/Z buttonleft_tab0, win=$k_panelName, disable=0
				Button/Z buttonright_tab0,win=$k_panelName, disable=0
			endif
			break
	endswitch
	
	return 0
end

// ***
// Contact Prints
end

// generate contact print layout
Function CreateContactPrintLayout()

	// global values
	DFREF cpf = $k_packageFolder + ":contactprint"

	variable cntp, ic, ip, pc, wsize
	string strName,fulllist="",porl,tilestr
	
	cntp = CountofContactPrints()
	
	if (cntp<=0)
		DoAlert/T="Contact Print", 0, "No images stored as contact prints."
		return 0
	endif

	if (cntp < 3)
		wsize = 8*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(0,2)"
	elseif (cntp < 5)
		wsize = 1.5*8*72/cntp
		porl = "PORTRAIT"
		tilestr = "Tile/A=(0,2)"
	elseif (cntp < 9)
		wsize = 1.5*10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(2,0)"
	elseif (cntp < 12)
		wsize = 1.5*10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(3,0)"
	else
		wsize = 10.5*72/cntp
		porl = "LANDSCAPE"
		tilestr = "Tile/A=(3,0)"
	endif
	
	for (ic=0;ic<cntp;ic+=1)
		strName = GetIndexedObjNameDFR(cpf,3,ic)
		fulllist += strName + ";"
		DoWindow/K/Z $strName
		SVAR/SDFR=cpf exCmd = $strName
		Execute/Q/Z exCmd
		DoWindow/C $strName
		ModifyGraph/W=$strname width=wsize
		DoWindow/HIDE=1 $strName
	endfor
	
	fullList = SortList(fullList)
	
	DoWindow/K/Z imgT_contactlayout
	NewLayout/P=$porl/N=imgT_contactlayout
	for (ic=0;ic<cntp;ic+=1)
		strName = StringFromList(ic,fulllist)
		AppendLayoutObject/F=0 graph $strName
	endfor
	Execute/Q/Z tilestr
	
	return 0
end

// checks whether the current image is already a contact print storage
Function IsContactPrint()

	// global values
	DFREF cpf = $k_packageFolder + ":contactprint"
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable tf=0, ic=0
	string cpstr,cpritem
	
	if (CountofContactPrints()==0)
		return tf
	endif
	
	cpstr = cwdfolder[5,inf] +"_"+cwfile
	
	do
		cpritem = GetIndexedObjNameDFR(cpf,3,ic)
		if (strlen(cpritem)==0)
			break
		endif
		if (cmpstr(cpstr,cpritem)==0)
			tf = 1
			break
		endif
		ic += 1
	while(1)

	return tf
end

// counts the number of contact prints stored
Function CountofContactPrints()

	// global values
	DFREF cpf = $k_packageFolder + ":contactprint"
	
	variable cnt = 0
	
	if (DataFolderExists(k_packageFolder + ":contactprint"))
		cnt = CountObjectsDFR(cpf,3)
	else
		cnt = -1
	endif
	
	return cnt
end

// remove a contact print recreaction string
Function ClearAllContactPrintImages()

	// global values
	if (!DataFolderExists(k_packageFolder + ":contactprint"))
		return 0
	endif
	
	DFREF cpf = $k_packageFolder + ":contactprint"
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable ic, npts
	string wStr
	
	npts = CountObjectsDFR(cpf,3)
	
	for (ic=0;ic<npts;ic+=1)
		wStr = GetIndexedObjNameDFR(cpf,3,ic)
		KillWindow/Z $wStr
	endfor
	
	KillDataFolder/Z cpf
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder pf
	NewDataFolder/O contactprint
	SetDataFolder cdf

	Checkbox checkCP_tab0, win=$k_panelName, value=0
	ValDisplay valdispccp_tab0, win=$k_panelName, value = 0
	
	return 0
end

// remove a contact print recreaction string
Function RemoveContactPrint()

	// global values
	DFREF cpf = $k_packageFolder + ":contactprint"
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string cpstr
	cpstr = cwdfolder + "_" + cwfile

	DFREF cdf = GetDataFolderDFR()
	SetDataFolder cpf
	killstrings/Z $cpstr
	killwindow/Z $cpstr
	
	SetDataFolder cdf

	return 0
end

// store contact print recreaction
Function StoreContactPrint([sfolder,sfile])
	string sfolder, sfile

	// global values
	DFREF cpf = $k_packageFolder + ":contactprint"
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	DFREF cdf = GetDataFolderDFR()
	
	if (ParamIsDefault(sfolder))
		sfolder = cwdfolder[5,inf]
	endif
	if (ParamIsDefault(sfile))
		sfile = cwfile
	endif

	string cpstrng, cprec, scprec
	string rgex = "((?s)(.)+)\\tNewPanel/HOST=#"
	string pstr, sstr
	
	SetDataFolder pf
	NewDataFolder/O/S contactprint
	
	cpstrng = sfolder + "_" + sfile
	cprec = WinRecreation(k_graphName,0)
	
	SplitString/E=(rgex) cprec, scprec
	
	sstr = "\tModifyGraph expand=0.5,lsize=1"
	sstr += "\r\tTextBox/C/N=name/F=0/A=LT \"\\Z08" + cpstrng + "\""
	sstr += "\rEndMacro"
	scprec += sstr
	
	string/G $cpstrng = scprec
	
	SetDataFolder cdf
	
	return 0
end

// update current image as contact print
Function UpdateContactPrint()

	if (IsContactPrint()==0)
		Checkbox checkCP_tab0, win=$k_panelName, value=0
		return 0
	endif
	
	StoreContactPrint()
	Checkbox checkCP_tab0, win=$k_panelName, value=1
	
	return 0

end

// ***
// LOAD IMAGES

// is an image loaded?
Function ImageLoaded()

	string st = LoFolders(cstr="imgT_*")

	if (strlen(st)==0)
		return 0
	else
		return 1
	endif
	
end

// number of image sets loaded
Function NImagesLoaded()

	variable ni
	ni = ItemsInList(LoImgT())
	return ni
end

// list of imgT folders
Function/S LoImgT()

	DFREF cdf = GetDataFolderDFR()

	SetDataFolder root:
	string lof = LoFolders(cstr="imgT_*")
	SetDataFolder cdf
	
	lof = ReplaceString("imgT_",lof,"")
	
	return lof
end

// create a folder to store an image
Function/S CreateImageFolder(fnsuffix)
	string fnsuffix
	
	SetDataFolder root:
	
	// create the new data folder and subfolder
	string fname = "imgT_" + cleanupname(fnsuffix,0)
	variable ic = 0, etrue = 1
	do
		if (DataFolderExists(fname))
			fname = fname + num2str(ic)
		else
			etrue = 0
		endif
	while(etrue)
	NewDataFolder/S $fname
	
	SetDataFolder root:
	
	return fname
end

// load a single TIFF image
Function LoadOneTIFFImg()
	
	// get load settings
	STRUCT LoadSettings ls
	GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	// select file	
	string fFilter = "TIF Images ONLY:.tif,.tiff;"
	variable refNum
	Open/D/R/F=fFilter/M="Select ONE TIFF image" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	// get path and file name
	string fPath, fFullName, fnsuffix, fnimg
	fPath = ParseFilePath(1,S_filename,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	fFullName = ParseFilePath(0,S_filename,":",1,0)
	
	// load the image file
	f_loadfile(fFullName,ls)
	
	SetDataFolder root:
	
	fFilter = DateTimeStamp() + " -> Loaded one TIFF image file from " + fPath
	fFilter += "\r\tFile: " + fFullName
	print fFilter
	
	return 0
end

// load a set of TIFF images
Function LoadMultipleTIFFImgs()
	
	// get load settings
	STRUCT LoadSettings ls
	GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;", pstr
	string fPath, fFullName, theFile, thefList = "", fnsuffix, fnimg
	variable refNum, ic, nf
	
	// select files
	Open/MULT=1/D/R/F=fFilter/M="Select multiple TIFF images" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	// get path and file names	
	theFile = StringFromList(0,S_filename,"\r")
	fPath = ParseFilePath(1,theFile,":",1,0)
	//theFirstFile = ParseFilePath(0,theFile,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	
	// loop through to load files
	nf = ItemsInLIst(S_filename,"\r")	
	for (ic=0;ic<nf;ic+=1)
		theFile = StringFromList(ic,S_filename,"\r")
		fFullName = ParseFilePath(0,theFile,":",1,0)
		f_loadfile(fFullName,ls)
		thefList += fFullName + ";"
	endfor
	
	SetDataFolder root:
	
	pstr = DateTimeStamp() + " -> Loaded multiple TIFF image files from " + fPath
	pstr += "\r\tFiles: " + thefList
	print pstr
		
	return 0
end

// load a folder of TIFF images
Function LoadaFolder()
	
	// get load settings
	STRUCT LoadSettings ls
	GetLoadSettings(ls)
	
	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	// select folder
	NewPath/O/Q/M="Select a folder with the TIF images"/Z imgPath
	if (v_flag!=0)
		return -1
	endif
	
	// load the folder

	variable ic, nf
	string flist, theFile, fPath, pstr

	flist = IndexedFile(imgPath,-1,".tif")

	nf = ItemsInList(flist,";")
	theFile = StringFromList(0,flist)
	fPath = ParseFilePath(1,theFile,":",1,0)

	for (ic=0;ic<nf;ic+=1)
		theFile = StringFromList(ic,flist)
		f_loadfile(theFile,ls)
	endfor

	SetDataFolder root:
	
	pstr = DateTimeStamp() + " -> Loaded a folder of TIFF image files from " + fPath
	pstr += "\r\tFiles: " + flist
	print pstr

	return 0

end

// load a stack of TIFF images
Function LoadStackTIFFImgs()
	
	// get load settings
	STRUCT LoadSettings ls
	GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;",pstr
	variable refNum

	// select files
	Open/MULT=0/D/R/F=fFilter/M="Select a TIFF image stack" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	string fPath, fFullName, theFile, theFirstFile, fnsuffix, fnimg
	string fSlicePrefix, fSliceName, FolderNameList=""
	variable ic, no, nf, ns, nmax, dn
	
	// get path and file names	
	theFile = S_filename
	fPath = ParseFilePath(1,theFile,":",1,0)
	fFullName = ParseFilePath(0,theFile,":",1,0)
	fSlicePrefix = ParseFilePath(3,theFile,":",0,0)
	NewPath/O/Q/Z imgPath, fPath
	
	// get number of images in stack
	NewDataFolder/O/S tmp
	ImageLoad/Q/C=0/T=TIFF/RTIO/P=imgPath theFile
	nmax = V_numImages
	
#ifdef DEBUG
	SetDataFolder ::
#else
	KillDataFolder :
#endif
	
	// set the loop parameters
	no = ls.startimage - 1
	ns = ls.stepimage
	
	if (numtype(ls.endimage)!=0)
		nf = nmax
	else
		nf = ns*ls.endimage
	endif

	// set the digits for sequencing image names
	dn = ls.startindex + nf*ls.stepindex
	dn = round(log(dn))
	
	// loop through to load images from stack
	for (ic=no;ic<nf;ic+=ns)
		FolderNameList += f_loadfile(fFullName,ls,stnum=ic,digits=dn) + ";"
	endfor
	
	pstr = DateTimeStamp() + " -> Loaded a TIFF image stack from " + fPath
	pstr += "\r\tFile: " + fFullName
	print pstr
	
	return 0
end

// load a file
Function/S f_loadfile(fname,ls,[stnum,digits])
	string fname
	STRUCT LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()
	fnprefix = StringFromList(0,fname,".")
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d"
		sprintf fnprefix fs, (ls.startindex + stnum*ls.stepindex)
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF
		
	// load the image file
	
	if (ParamIsDefault(stnum))
		ImageLoad/RAT/P=imgPath/N=source/Q fname
	else
		ImageLoad/RAT/P=imgPath/S=(stnum)/C=1/Q fname
	endif
	
	// clean up file name
	imgname = StringFromList(0,s_wavenames)
	wave source=$imgname
	rename source img_source
	wave img_source
	
	// generate red
	if (ls.red)
		ImageTransform/P=0 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_red
	endif
	
	// generate green
	if (ls.green)
		ImageTransform/P=1 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_green
	endif
	
	// generate blue
	if (ls.blue)
		ImageTransform/P=2 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_blue
	endif
	
	// generate gray
	if (ls.gray)
		ImageTransform rgb2gray img_source
		wave M_RGB2Gray
		rename M_RGB2Gray img_gray
	endif
	
	// keep source?
	if (!ls.source)
		killwaves/Z img_source
	endif
	
	// store the load parameters
	NewDataFolder/O/S imgT_loadparams
	string/G sDateLoaded = DateTimeStamp()
	variable/G imgred, imggreen, imgblue, imgsource, imggray	
	imgred = ls.red
	imggreen = ls.green
	imgblue = ls.blue
	imggray = ls.gray
	imgsource = ls.source

	SetDataFolder cdf
	return newFldrName
end

// ***
// SHOW IMAGE

// show an image
Function ShowAnImage()

	// globals for package	
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	variable iN
	string fstr, tstr
	
	// set the folder and image
	fstr = "root:" + cwdfolder
	DFREF imgF = $fstr	
	wave/SDFR=imgF itd = $cwfile
	
	tstr = RemoveEnding(ImageNameList("imgT_display",";"))
	ReplaceWave /W=$k_graphName image=$tstr, itd
	
	
	
	return 0
end

// step thru images
// -1 back; 0 stay; 1 forward
Function StepThruImages(how)
	variable how
	
	string simg = LoimgT()
	variable nimg = ItemsInList(simg)
	
	ControlInfo/W=$k_panelName popupFolder_tab0
	switch(how)
		case -1:		// step back one image
			if (V_value == 1)
				break
			endif
			ResetImageFolder(V_value-1)
			ShowAnImage()
			AppendHistograms(1)
			V_value -= 1
			simg = StringFromList(V_value-1,simg,";")
			PopupMenu popupFolder_tab0, win=$k_panelName, mode=V_value, popvalue=simg
			ResetImageFileonPanel()
			break
		case 0:		// new image
			ResetImageFolder(V_value)
			ShowAnImage()
			AppendHistograms(1)
			ResetImageFileonPanel()
			break
		case 1:		// step forward one image
			if (V_value == nimg)
				break
			endif
			ResetImageFolder(V_value+1)
			ShowAnImage()
			AppendHistograms(1)
			V_value += 1
			ResetImageFileonPanel()
			break
	endswitch
	
	simg = StringFromList(V_value-1,simg,";")
	PopupMenu popupFolder_tab0, win=$k_panelName, mode=V_value, popvalue=simg
	Button buttonleft_tab0, win=$k_panelName, disable=0
	Button buttonright_tab0, win=$k_panelName, disable=0
	
	if (nimg == 1)
		Button buttonleft_tab0, win=$k_panelName, disable=2
		Button buttonright_tab0, win=$k_panelName, disable=2
		return 0
	endif

	if (V_value == 1)
		Button buttonleft_tab0, win=$k_panelName, disable=2
	else
		Button buttonleft_tab0, win=$k_panelName, disable=0		
	endif
	
	if (V_value == nimg)
		Button buttonright_tab0, win=$k_panelName, disable=2
	else
		Button buttonright_tab0, win=$k_panelName, disable=0		
	endif
	
	return 0
end

// reset image folder
Function ResetImageFolder(fnum)
	variable fnum
	
	// global values
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	// reset the global folder
	string flist = LoimgT()
	cwdfolder = "imgT_" + StringFromList(fnum-1,flist,";")
	
	// reset the file to the first one in the folder when needed
	flist = "img_" + LoimgF(sfolder=cwdfolder)
	fnum = WhichListItem(cwfile,flist)
	if (fnum < 0)
		cwfile = StringFromList(0,flist,";")
		PopupMenu popupfile_tab0, win=$k_panelName, value=LoimgF(), mode = 1, userData=cwfile
	endif

	return 0

end

// reset image file on panel
Function ResetImageFileonPanel()
	
	// global values
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable fnum
	string flist = LoimgF(), ffile

	// reset the file
	ffile = cwfile[4,inf]
	fnum = WhichListItem(ffile,flist)
	PopupMenu popupfile_tab0, win=$k_panelName, mode=fnum+1, popvalue=ffile

	return 0

end

// ***
// HISTOGRAMS

// generate the histogram
Function GenerateHistograms(toRoI)
	variable toRoI
	
	DFREF cdf = GetDataFolderDFR()

	// global values
	DFREF pf = $k_packageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string dfstr, imgHstr, imgroot, maskWave
	variable quiet=0, maskordraw, wtype
	variable bflag=0, tflag=0, dhmin, dhmax
	
	dfstr = "root:" + cwdfolder
	DFREF wf = $dfstr
	dfstr += ":imgT_loadparams"
	DFREF iTf = $dfstr
	
	imgroot = StringFromList(1,cwfile,"_")
	
	SetDataFolder wf
	wave wimg = $cwfile
	
	NewDataFolder/O/S $k_histFolder
	
	// 8bit or 16bit
	
	wtype = WaveType(wimg,0)	
	if (wtype & 0x08)
		bflag = 0		// 8 bit
	elseif (wtype & 0x10)
		bflag = 1		// 16 bit
	endif
	
	// single channel or three channel
	wtype = WaveDims(wimg)
	if (wtype == 3)
		tflag = 1
	endif
	
	// negative input means read from panel
	
	if (toRoI < 0)
		ControlInfo/W=$k_panelName checksethRoI_tab0
		toRoI = v_value
		quiet = 1
	endif
	
	// generate histogram
		
	switch(toRoI)
		case 0:		// histogram over all image
			ImageHistogram wimg
			CheckBox/Z checklockhRoI_tab0, win=$k_panelName, value=0, disable=2
			break
		case 1:		// histogram over RoI or not
			if (GenerateHistogramRoIMask(wimg,quiet)!=0)
				maskWave = cwfile + "_HRoIMask"
				wave RoIWave=$maskWave
				ImageHistogram/R=RoIWave wimg
				CheckBox/Z checklockhRoI_tab0, win=$k_panelName, disable=0
			else
				ImageHistogram wimg
				CheckBox/Z checksethRoI_tab0, win=$k_panelName, value=0
				CheckBox/Z checklockhRoI_tab0, win=$k_panelName, value=0, disable=2
			endif
			break
	endswitch
	
	switch(tflag)
		case 0:		// single channel image
			wave iHo = W_imageHist
			break
		case 1:		// rgb image
			wave iHRo = W_imageHistR
			wave iHGo = W_imageHistG
			wave iHBo = W_imageHistB
			duplicate/O/FREE iHRo, iHo
			iHo += iHGo + iHBo
			break
	endswitch	
	
	imgHstr = "hist_" + imgroot	
	duplicate/O iHo, $imgHstr
	wave iH = $imgHstr
	if (!bflag)
		SetScale/P x 0,1,"", iH
	endif
	
	imgHstr = "chist_" + imgroot
	duplicate/O iH, $imgHstr
	wave iCH = $imgHstr
	integrate/T iCH /D=iCH
	
	imgHstr = "dhist_" + imgroot
	duplicate/O iH, $imgHstr
	wave iDH = $imgHstr
	differentiate iDH /D=iDH
	WaveStats/Q iDH
	dhmax = max(abs(v_max),abs(v_min))
	iDH /= dhmax
	
#ifndef DEBUG
	killwaves/Z W_imageHist, W_imageHistR, W_imageHistG, W_imageHistB
#endif
	
	SetDataFolder cdf

	return 0
end

// generate an RoI mask
Function GenerateHistogramRoIMask(wimg,quiet)
	wave wimg
	variable quiet

	variable rtn = 0	
	variable ppx0, ppx1, ppy0, ppy1
	string maskName
	
	// get marquee from image graph	
	STRUCT MarqueeCoordinates mc
	GetMCCoordinates(mc)
	
	// no marquee or drawing for histogram
	if (!mc.hasmarquee && !mc.hasdrawing)
		if (!quiet)
			DoAlert/T="Restrict Histogram" 0, "No marquee region is present. Set a marquee region and try again."
		endif
		Checkbox checksethRoI_tab0, win=$k_panelName, value=0
		Checkbox checklockhRoI_tab0, win=$k_panelName, value=0, disable=2
		return rtn
	endif
	
	// put trunated pixel coordinates in local variables
	ppx0 = trunc(mc.pgleft)
	ppy0 = trunc(mc.pgtop)
	ppx1 = trunc(mc.pgright)
	ppy1 = trunc(mc.pgbottom)
	
	// store RoI values for the displayed image
	variable/G ihcpx0 = ppx0, ihcpx1 = ppx1, ihcpy0 = ppy0, ihcpy1 = ppy1
	maskName = NameofWave(wimg) + "_HRoIMask"
	duplicate/O wimg, $maskName
	wave imgMask = $maskName
	if (WaveDims(wimg) == 3)
		Redimension/B/U/N=(-1,-1,1) imgMask
	else
		Redimension/B/U imgMask
	endif
	imgMask = NaN
	imgMask[ppx0,ppx1][ppy0,ppy1] = 0
	
	rtn = 1
	
	return rtn

end

// scale the derivative of the histogram
Function ScaleDHistogram(sf)
	variable sf
	
	variable dhmin, dhmax
	dhmin = -(10^(-sf))
	dhmax = (10^(-sf))
	SetAxis/W=$k_graphName dhist dhmin,dhmax

	return 0	
end

// ***
// GENERAL PURPOSE

// list of folders in a sdfr following a cstr string convention
Function/S LoFolders([sdfr,cstr])
	string cstr
	DFREF sdfr
	
	if (!ParamIsDefault(sdfr))
		SetDataFolder sdfr
	endif
	
	string tstr = "", lstr = ""
	variable ic
	do
		tstr = GetIndexedObjName("",4,ic)
		if (strlen(tstr)==0)
			break
		else
			lstr += tstr + ";"
		endif
		ic += 1
	while (1)
	
	if (!ParamIsDefault(cstr))
		lstr = ListMatch(lstr,cstr,";")
	endif
	
	return lstr
end

// image files in a given folder
Function/S LoimgF([sfolder])
	string sfolder
	
	string lfiles = ""
	
	// no valid folders
	lfiles = LoimgT()
	if (cmpstr(lfiles[0,1],"**") == 0)
		return "** No Folder Loaded **;"
	endif
	
	if (!ParamIsDefault(sfolder))
		DFREF imgF = root:$sfolder
	else
		ControlInfo/W=$k_panelName popupfolder_tab0
		lfiles = "imgT_" + S_value
		DFREF imgF = root:$lfiles
	endif
	
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder imgF
	lfiles = ReplaceString("img_",WaveList("img_*",";",""),"")
	SetDataFolder cdf
	
	return lfiles
end

// put a date+time stamp
// [dsep] - in date; [tsep] - in time; [dtsep] - between date and time
Function/S DateTimeStamp([dsep, tsep, dtsep])
	string dsep, tsep, dtsep
 
	string a, b, c, dstr, tstr, gExp
 
	if (ParamIsDefault(dsep))
		dsep = "-"
	endif
	if (ParamIsDefault(tsep))
		tsep = ":"
	endif
	if (ParamIsDefault(dtsep))
		dtsep = "/"
	endif
 
	gExp = "([0-9]+):([0-9]+)"	
	SplitString/E=(gExp) secs2time(datetime,2), a, b
	tstr = a + tsep + b
 
	gExp = "([0-9]+)/([0-9]+)/([0-9]+)"	
	SplitString/E=(gExp) secs2date(datetime,-1), a, b, c
	dstr = c[2,3] + dsep + b + dsep + a
 
	return (dstr + dtsep +  tstr) 
end

// check whether popup has been changed
// uses userdata
// returns 1 when changed or 0 when not
Function PopHasChanged(pa)
	STRUCT WMPopupAction &pa
	
	if (cmpstr(pa.popStr,pa.userdata)==0)
		return 0
	else
		pa.userdata = pa.popStr
		return 1
	endif
end

// ***
// PANEL CONTROL FUNCTIONS

// tab procedure
Function TabProc(tca) : TabControl
	STRUCT WMTabControlAction &tca

	variable ctab
	
	switch( tca.eventCode )
		case 2: // mouse up
			ctab = tca.tab

#ifndef DEBUG
			// no switching to other tabs until an image is loaded
			if (!ImageLoaded())
				TabControl main, win=$k_panelName, value = 0
				ctab = 0
				return 0
			endif
#endif				
			// switch to other tabs ... initialize any selections
			InitializeTabMenus(ctab)
			
			// show/hide tabs on panel
			string tablist
			tabList = ControlNameList(k_panelName,";","*_tab0")
			ModifyControlList/Z tabList, disable=!(ctab==0)
			
			// clean up controls in special cases
			CleanupTabControls(ctab)		
			
			ControlUpdate/A/W=$k_panelName
		case -1: // control being killed
			break
	endswitch

	return 0
end

// button control procedure
Function ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	variable nimgs, brkout
	
	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			strswitch(ba.ctrlName)
				case "buttonLoad_tab0":
					nimgs = NImagesLoaded()
					ControlInfo/W=$k_panelName popupload_tab0
					switch(v_value)
						case 1:
							brkout = LoadOneTIFFimg()
							break
						case 2:
							brkout = LoadMultipleTIFFimgs()
							break
						case 3:
							brkout = LoadaFolder()
							break
						case 4:
							brkout = LoadStackTiffimgs()
							break
					endswitch
					// replace image if this is the first
					if (nimgs == 0 && brkout >= 0)
						StepThruImages(0)
						UpdateContactPrint()
						InitializeTabMenus(100)
					else
						StepThruImages(0)
						InitializeTabMenus(0)
					endif
					ControlUpdate/A/W=$k_panelName
					break
				case "buttonleft_tab0":
					StepThruImages(-1)	
					UpdateContactPrint()
					break
				case "buttonright_tab0":
					StepThruImages(1)
					UpdateContactPrint()
					break
				case "buttonRedoH_tab0":
					AppendHistograms(1)
					UpdateContactPrint()
					break
				case "buttonDoCPrint_tab0":
					CreateContactPrintLayout()
					break
				case "buttonClearAll_tab0":
					ClearAllContactPrintImages()
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	
	return 0
end

// slider procedure
Function SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa

	string tnstr
	variable dhmin, dhmax
	
	switch( sa.eventCode )
		case -3: // Control received keyboard focus
		case -2: // Control lost keyboard focus
		case -1: // Control being killed
			break
		default:
			if( sa.eventCode & 1 ) // value set
				ScaleDHistogram(sa.curval)
			endif
			break
	endswitch

	return 0
End

// popmenu procedure
Function PopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			if (!PopHasChanged(pa))
				return 0
			endif
			strswitch(pa.ctrlName)
				case "popupload_tab0":
					CleanUpTabControls(0)
					break
				case "popupFolder_tab0":
					// change to a new folder
					StepThruImages(0)
					UpdateContactPrint()
					break
				case "popupFile_tab0":
					// change to a new file
					ShowAnImage()
					AppendHistograms(1)
					UpdateContactPrint()
					ResetImageFileonPanel()
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end

// checkbox procedure
Function CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			strswitch(cba.ctrlName)
				case "checksethRoI_tab0":
					GenerateHistograms(cba.checked)
					break
				case "checklockhRoI_tab0":
					LockHistogramRoI(cba.checked)
					break
				case "checkCP_tab0":
					switch(cba.checked)
						case 0:
							RemoveContactPrint()
							break
						case 1:
							StoreContactPrint()
							break
					endswitch
					ValDisplay valdispccp_tab0 win=$k_panelName, value=_NUM:CountofContactPrints()
					break
				case "checkshowhist_tab0":
					ShowHideHistograms(cba.checked)
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end
